import javax.swing.*;

/**
 * This class defines an piece in a "connect 4 game". It includes a symbol
 * character that uniquely identifies the piece and displays it in text
 * based interfaces, and an image icon that displays it in GUI interfaces.
 * Has various methods for accessing and comparing its members.
 * @author Kenneth Marino
 * @version 1.0 3/14/2012
 */
public class Piece
{
	// Constant character to represent empty spaces
	public static final char EMPTY_PIECE = '*';

	// Instance variables
	private char symbol;
	private ImageIcon icon;
	
	/**
	 * Constructor. Sets the symbol and image of the piece.
	 * @param symbol The symbol representing the piece
	 * @param icon The image representing the piece
	 */
	public Piece(char symbol, ImageIcon icon)
	{
		this.symbol = symbol;
		this.icon = icon;
	}
	
	/**
	 * This method returns a String representation of the
	 * object. 
	 * @return String representation
	 */
	public String toString()
	{
		return symbol + "";
	}
	
	/**
	 * This method returns the ImageIcon representing the piece.
	 * @return ImageIcon representing the piece
	 */
	public ImageIcon getImageIcon()
	{
		return icon;
	}
	
	/**
	 * Compares the piece to the input piece, and returns true 
	 * if they are equal.
	 * @param other The Piece object to be compared
	 * @return A boolean value: true if the Pieces are equal
	 */
	public boolean equals(Piece other)
	{
		return ((symbol + "").compareTo(other.toString()) == 0);
	}
}